Index: /trunk/contactcenter/inc/class.ui_data.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.ui_data.inc.php	(revision 276)
+++ /trunk/contactcenter/inc/class.ui_data.inc.php	(revision 284)
@@ -2418,59 +2602,59 @@
 			ldap_close($ds);
 			echo serialize($array_participants);
-		}	
-		
-		function get_catalog_participants_list($id) 
+		}
+
+		function get_catalog_participants_list($id)
 		{
-			
-			$fields = $this->bo->catalog->get_fields(false);			
+
+			$fields = $this->bo->catalog->get_fields(false);
 			$fields['names_ordered'] = true;
-			$fields['mail_forwarding_address'] = true;			
-			$contact = $this->bo->catalog->get_single_entry($id,$fields);			
-			
+			$fields['mail_forwarding_address'] = true;
+			$contact = $this->bo->catalog->get_single_entry($id,$fields);
+
 			$array_participants = array();
 			$array_emails = array();
-			
+
 			$filter = null;
-			for($z = 0; $z < $contact['mail_forwarding_address']['count']; $z++) {			
+			for($z = 0; $z < $contact['mail_forwarding_address']['count']; $z++) {
 					if(strstr($contact['mail_forwarding_address'][$z],'@')) {
 						$filter.="(mail=".$contact['mail_forwarding_address'][$z].")";
 						$array_emails[$contact['mail_forwarding_address'][$z]] = "<font color=black>".$contact['mail_forwarding_address'][$z]."</font>";
-					}																
-					else 
+					}
+					else
 						$array_participants[$z] = "<font color=red>".$contact['mail_forwarding_address'][$z]."</font>";
-			}					
-			
+			}
+
 			if($filter) {
-				$filter = "(|".$filter.")";							
+				$filter = "(|".$filter.")";
 				if(!$this->bo->catalog->src_info) {
 					$ldap = CreateObject('contactcenter.bo_ldap_manager');
 					$this->bo->catalog->src_info = $ldap->srcs[1];
 				}
-				$ds = $GLOBALS['phpgw']->common->ldapConnect($this->bo->catalog->src_info['host'], $this->bo->catalog->src_info['acc'], $this->bo->catalog->src_info['pw'], true);				
+				$ds = $GLOBALS['phpgw']->common->ldapConnect($this->bo->catalog->src_info['host'], $this->bo->catalog->src_info['acc'], $this->bo->catalog->src_info['pw'], true);
 				$dn=$this->bo->catalog->src_info['dn'];
 				$justThese = array("cn","mail");
-				$sr = ldap_search($ds,$dn, $filter,$justThese);								
-				$info = ldap_get_entries($ds, $sr);							
+				$sr = ldap_search($ds,$dn, $filter,$justThese);
+				$info = ldap_get_entries($ds, $sr);
 				for($z = 0; $z < $info['count']; $z++) {
 					$participant =  '<font color=\'DARKBLUE\'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&quot;'.$info[$z]['cn'][0].'&quot; &lt;'.$info[$z]['mail'][0].'&gt;</font><br>';
-					$array_emails[$info[$z]['mail'][0]] = null; 								
-					array_push($array_participants, $participant);					
-				}
-				
+					$array_emails[$info[$z]['mail'][0]] = null;
+					array_push($array_participants, $participant);
+				}
+
 				foreach($array_emails as $index => $email)
-					if($email) 
-						array_push($array_participants, "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$email."<br>");				
-												
+					if($email)
+						array_push($array_participants, "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$email."<br>");
+
 				ldap_close($ds);
 			}
 			sort($array_participants);
-			$innerHTML = '';			
+			$innerHTML = '';
 			foreach($array_participants as $index => $participant){
 				$innerHTML .= $participant;
 			}
-			$return = array('size' => count($array_participants), 'names_ordered'=> $contact['names_ordered'], 'inner_html' => $innerHTML);			 
+			$return = array('size' => count($array_participants), 'names_ordered'=> $contact['names_ordered'], 'inner_html' => $innerHTML);
 			echo serialize($return);
-		}	
-		
+		}
+
 		function export_contacts($typeExport){
 
@@ -2483,5 +2667,5 @@
 
 
-			// Essa iteração transforma uma esturuta com contatos redundantes e separados por email ou tel.
+			// Essa iteraï¿œï¿œo transforma uma esturuta com contatos redundantes e separados por email ou tel.
 			// em outra com apenas 1 elemento pra cada contato
 			$i=0;
@@ -2494,45 +2678,45 @@
 					$all_contacts[$i]['phone']=$object['connection_value'];
 			}
-			
+
 			switch($typeExport) {
 
 				case 'outlook_en':
 					$streamBuffer = "Name;E-mail Address;Notes;Mobile Phone;Pager;Company;".
-							"Job Title;Home Phone;Home Fax;Business Phone;Business Fax\r\n";							
+							"Job Title;Home Phone;Home Fax;Business Phone;Business Fax\r\n";
 					foreach($all_contacts as $index => $object){
 						$streamBuffer.= $object['name'].";".$object['email'].";;;;;;".$object['phone'].";;;\r\n";
 					}
 				break;
-				
+
 				case 'outlook_pt-BR':
-					$streamBuffer = "Nome;End. de email;Endereço residencial;".
-					"Cidade do endereço residencial;CEP do endereço residencial;".
-					"Estado;País/região do endereço residencial;Telefone residencial;".
-					"Rua do endereço comercial;Cidade do endereço comercial;".
-					"CEP do endereço comercial;Estado do endereço comercial;".
-					"País/região do endereço comercial;Telefone comercial;Empresa;Cargo\r\n";							
+					$streamBuffer = "Nome;End. de email;Endereï¿œo residencial;".
+					"Cidade do endereï¿œo residencial;CEP do endereï¿œo residencial;".
+					"Estado;Paï¿œs/regiï¿œo do endereï¿œo residencial;Telefone residencial;".
+					"Rua do endereï¿œo comercial;Cidade do endereï¿œo comercial;".
+					"CEP do endereï¿œo comercial;Estado do endereï¿œo comercial;".
+					"Paï¿œs/regiï¿œo do endereï¿œo comercial;Telefone comercial;Empresa;Cargo\r\n";
 					foreach($all_contacts as $index => $object){
 						$streamBuffer.= $object['name'].";".$object['email'].";;;;;;".$object['phone'].";;;;;;;;\r\n";
 					}
 				break;
-				
+
 				case 'outlook2000_pt-BR':
 					$streamBuffer = "\"Tratamento\",\"Nome\",\"Segundo Nome\",\"Sobrenome\",\"Sufixo\",".
-					"\"Empresa\",\"Departamento\",\"Cargo\",\"Rua do endereço comercial\",\"Rua do endereço comercial 2\",".
-					"\"Rua do endereço comercial 3\",\"Cidade do endereço comercial\",\"Estado do endereço comercial\",".
-					"\"CEP do endereço comercial\",\"País do endereço comercial\",\"Endereço residencial\",\"Rua residencial 2\",".
-					"\"Rua residencial 3\",\"Cidade do endereço residencial\",\"Estado\",\"CEP do endereço residencial\",\"País do endereço residencial\",".
-					"\"Outro endereço\",\"Outro endereço 2\",\"Outro endereço 3\",\"Cidade\",\"Estado\",\"CEP\",\"País\",".
+					"\"Empresa\",\"Departamento\",\"Cargo\",\"Rua do endereï¿œo comercial\",\"Rua do endereï¿œo comercial 2\",".
+					"\"Rua do endereï¿œo comercial 3\",\"Cidade do endereï¿œo comercial\",\"Estado do endereï¿œo comercial\",".
+					"\"CEP do endereï¿œo comercial\",\"Paï¿œs do endereï¿œo comercial\",\"Endereï¿œo residencial\",\"Rua residencial 2\",".
+					"\"Rua residencial 3\",\"Cidade do endereï¿œo residencial\",\"Estado\",\"CEP do endereï¿œo residencial\",\"Paï¿œs do endereï¿œo residencial\",".
+					"\"Outro endereï¿œo\",\"Outro endereï¿œo 2\",\"Outro endereï¿œo 3\",\"Cidade\",\"Estado\",\"CEP\",\"Paï¿œs\",".
 					"\"Telefone do assistente\",\"Fax comercial\",\"Telefone comercial\",\"Telefone comercial 2\",\"Retorno de chamada\",".
 					"\"Telefone do carro\",\"Telefone principal da empresa\",\"Fax residencial\",\"Telefone residencial\",".
 					"\"Telefone residencial 2\",\"ISDN\",\"Telefone celular\",\"Outro fax\",\"Outro telefone\",\"Pager\",\"Telefone principal\",".
-					"\"Radiofone\",\"Telefone TTY/TDD\",\"Telex\",\"Aniversário\",\"Anotações\",\"Caixa postal\",\"Categorias\",".
-					"\"Código da empresa\",\"Código do governo\",\"Cônjuge\",\"Conta\",\"Endereço de correio eletrônico\",".
-					"\"Nome de exibição do correio eletr.\",\"Endereço de correio eletrônico 2\",".
-					"\"Nome de exibição do correio eletr.2\",\"Endereço de correio eletrônico 3\",".
-					"\"Nome de exibição do correio eletr.3\",\"Datas especiais\",\"Disponibilidade da Internet\",".
-					"\"Filhos\",\"Hobby\",\"Idioma\",\"Indicação\",\"Informações para cobrança\",\"Iniciais\",\"Local\",".
-					"\"Nome do assistente\",\"Nome do gerenciador\",\"Página da Web\",\"Palavras-chave\",\"Particular\",\"Personalizado 1\",\"Personalizado 2\",".
-					"\"Personalizado 3\",\"Personalizado 4\",\"Prioridade\",\"Profissão\",\"Quilometragem\",\"Sala\",\"Sensibilidade\",\"Servidor de diretório\",".
+					"\"Radiofone\",\"Telefone TTY/TDD\",\"Telex\",\"Aniversï¿œrio\",\"Anotaï¿œï¿œes\",\"Caixa postal\",\"Categorias\",".
+					"\"Cï¿œdigo da empresa\",\"Cï¿œdigo do governo\",\"Cï¿œnjuge\",\"Conta\",\"Endereï¿œo de correio eletrï¿œnico\",".
+					"\"Nome de exibiï¿œï¿œo do correio eletr.\",\"Endereï¿œo de correio eletrï¿œnico 2\",".
+					"\"Nome de exibiï¿œï¿œo do correio eletr.2\",\"Endereï¿œo de correio eletrï¿œnico 3\",".
+					"\"Nome de exibiï¿œï¿œo do correio eletr.3\",\"Datas especiais\",\"Disponibilidade da Internet\",".
+					"\"Filhos\",\"Hobby\",\"Idioma\",\"Indicaï¿œï¿œo\",\"Informaï¿œï¿œes para cobranï¿œa\",\"Iniciais\",\"Local\",".
+					"\"Nome do assistente\",\"Nome do gerenciador\",\"Pï¿œgina da Web\",\"Palavras-chave\",\"Particular\",\"Personalizado 1\",\"Personalizado 2\",".
+					"\"Personalizado 3\",\"Personalizado 4\",\"Prioridade\",\"Profissï¿œo\",\"Quilometragem\",\"Sala\",\"Sensibilidade\",\"Servidor de diretï¿œrio\",".
 					"\"Sexo\"\r\n";
 					foreach($all_contacts as $index => $object){
@@ -2540,5 +2724,5 @@
 					}
 				break;
-				
+
 				case 'outlook2000_en':
 					$streamBuffer = "Title,First Name,Middle Name,Last Name,Suffix,Company,Department,Job Title,".
@@ -2556,13 +2740,13 @@
 					}
 				break;
-					
+
 				case 'thunderbird':
-					$streamBuffer = "\n";							
+					$streamBuffer = "\n";
 					foreach($all_contacts as $index => $object){
 						$streamBuffer.= ",,".$object['name'].",,".$object['email'].",,".$object['phone'].",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,\r\n";
 					}
 				break;
-				
-				case 'expresso':
+
+				default:
 					$streamBuffer = "Nome,Email,Telefone\r\n";
 					foreach($all_contacts as $index => $object){
@@ -2570,5 +2754,5 @@
 					}
 				break;
-				
+
 			}
 
@@ -2578,5 +2762,5 @@
 			if(!$f)
 				echo null;
-		
+
 			fputs($f,$streamBuffer);
 			fclose($f);
@@ -2585,56 +2769,15 @@
 		}
 
-		// Get the csv field and put into array, from php.net
-		function parse_line($input_text, $delimiter = ',', $text_qualifier = '"') {
-  			$text = trim($input_text);
-  			  if(is_string($delimiter) && is_string($text_qualifier)) {
-       			 $re_d = '\x' . dechex(ord($delimiter));            //format for regexp
-        		$re_tq = '\x' . dechex(ord($text_qualifier));    //format for regexp
-        		
-        		$fields = array();
-        		$field_num = 0;
-        		while(strlen($text) > 0) {
-            		if($text{0} == $text_qualifier) {
-                		preg_match('/^' . $re_tq . '((?:[^' . $re_tq . ']|(?<=\x5c)' . $re_tq . ')*)' . $re_tq . $re_d . '?(.*)$/', $text, $matches);
-		               
-        		        $value = str_replace('\\' . $text_qualifier, $text_qualifier, $matches[1]);
-             			$text = trim($matches[2]);
-               
-                		$fields[$field_num++] = $value;
-            		} else {
-                		preg_match('/^([^' . $re_d . ']*)' . $re_d . '?(.*)$/', $text, $matches);
-		               
-        		        $value = $matches[1];
-               			$text = trim($matches[2]);
-               
-              		  	$fields[$field_num++] = $value;
-            	}
-        	}
-        		return $fields;
-		    } else
-       			return false;
-		}
 
 		function import_contacts($typeImport){
 
-			if($file = $_SESSION['contactcenter']['importCSV']) {				
-				unset($_SESSION['contactcenter']['importCSV']);				
+			$delim 		= ($typeImport == 'outlook' ? ';' : ',');
+
+			if($file = $_SESSION['contactcenter']['importCSV']) {
+				unset($_SESSION['contactcenter']['importCSV']);
 				$len = filesize($file);
 				$count = 0;
 				$return = array('error' => false, '_new' => 0, '_existing' => 0, '_failure' => 0);
    				$handle = @fopen($file, "r") or die(serialize($return['error'] = true));
-   				
-				$input_header = fgets($handle);
-				if ($typeImport == 'outlook')
-					$delim = ';';
-				else if ($typeImport == 'auto')
-				$delim = strstr($input_header,',') ? ',' : ';';
-				else  
-					$delim = ',';
-				$csv_header = $this->parse_line($input_header,$delim);
-				$firstContact = fgets($handle);
-				preg_match("/\"(.+)\"[,;]/sU",$firstContact,$matches); // yahoo csv
-   				rewind($handle);	   			
-
    				$header = @fgetcsv($handle, $len, $delim) or die(serialize($return['error'] = true));
    				if(count($header)  < 2 || count($header) > 100) {
@@ -2644,10 +2787,8 @@
    					return;
    				}
-   				
-   				if ($matches[0][strlen($matches[0])-1] == ';')
-					$delim = ';';
-   				
-			$boGroup = CreateObject('contactcenter.bo_group');
-			$boPeople = CreateObject('contactcenter.bo_people_catalog');
+
+				$boGroup = CreateObject('contactcenter.bo_group');
+				$boPeople = CreateObject('contactcenter.bo_people_catalog');
+
 				switch($typeImport){
 					case 'outlook2000':
@@ -2666,42 +2807,15 @@
 						$phone_pos=7;
 						break;
-					case 'expresso':
+					default:
 						$name_pos=0;
 						$email_pos=1;
 						$phone_pos=2;
-						break;
-					default:
-						foreach($csv_header as $index => $fieldName)
-						{
-							switch($fieldName){
-							case 'Name':
-							case 'Nome':
-							case 'First Name':
-								$name_pos = $index;
-								break;
-							case 'E-mail':
-							case 'Email':
-							case 'E-mail Address':
-							case 'Endereço de correio eletrônico':
-							case 'End. de email':
-								$email_pos = $index;
-								break;
-							case 'Home Phone':
-							case 'Phone':
-							case 'Telefone':
-							case 'Telefone principal':
-							case 'Telefone comercial':
-								$phone_pos = $index;
-								break;
-							}
-						}	
-						break;
-				}
-				
+				}
 
 				while (($data = fgetcsv($handle, $len, $delim))) {
+
        				foreach ($header as $key=>$heading)
                			$row[$heading]=(isset($data[$key])) ? $data[$key] : '';
-       				
+
 					$sdata = array();
 					$full_name  = trim($row[$header[$name_pos]]);
@@ -2717,23 +2831,20 @@
 					$sdata['connections']['default_phone']['connection_name'] = lang('Main');
 					$sdata['connections']['default_phone']['connection_value'] = $phone;
-					
-					// 	verifica se email já existe!
+
+					// 	verifica se email jï¿œ existe!
 					$contact = $boGroup->verify_contact($email);
 
-					$line_iteration = $return['_failure'] + $return['_existing'] + $return['_new']; 
 					if($contact){
 						$return['_existing']++;
-					}														
+					}
 					else if(!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email)) {
 						$return['_failure']++;
-						$return['_failure_status'] .= "Line: " . ($line_iteration + 2) . ", Invalid E-Mail address: " . $email ."<br>";
 					}
-					else if (!$sdata['given_names'] || !$email || !$boPeople ->quick_add($sdata)){						
-						$return['_failure']++;							
-						$return['_failure_status'] .= "Line: " . ($line_iteration + 2) . ", Invalid Name: " . $sdata['given_names'] ."<br>";
+					else if (!$sdata['given_names'] || !$email || !$boPeople ->quick_add($sdata)){
+						$return['_failure']++;
 					}
 					else
 						$return['_new']++;
-       			}       			
+       			}
    				fclose($handle);
 				unlink($file);
@@ -2749,5 +2860,5 @@
 			$new = null;
 			$code = null;
-			
+
 			if ($parent === '0')
 			{
@@ -2755,5 +2866,5 @@
 				$code .= $name.".add(new dNode({id:'0', caption: '".lang('Catalogues')."'}),'none');\n";
 			}
-			
+
 			foreach ($tree as $id => $value)
 			{
@@ -2761,11 +2872,11 @@
 
 				switch ($value['type'])
-				{					
+				{
 					case 'unknown':
-						$code .= $name.".add(new dNode({id: '{$parent}.{$id}', caption:'{$value['name']}', onFirstOpen: 'getCatalogTree(\\'{$parent}.{$id}\\');', onClick: 'getCatalogTree(\\'{$parent}.{$id}\\'); waitForTree(\\'{$parent}.{$id}\\', 0)'}),'$parent');\n"; 
+						$code .= $name.".add(new dNode({id: '{$parent}.{$id}', caption:'{$value['name']}', onFirstOpen: 'getCatalogTree(\\'{$parent}.{$id}\\');', onClick: 'getCatalogTree(\\'{$parent}.{$id}\\'); waitForTree(\\'{$parent}.{$id}\\', 0)'}),'$parent');\n";
 						break;
-					
+
 					case 'catalog_group':
-						$code .= $name.".add(new dNode({id: '{$parent}.{$id}', caption: '{$value['name']}'}),'$parent');\n"; 
+						$code .= $name.".add(new dNode({id: '{$parent}.{$id}', caption: '{$value['name']}'}),'$parent');\n";
 						$code .= $this->convert_tree($value['sub_branch'],$name,$iconDir,$parent.'.'.$id);
 						break;
@@ -2776,11 +2887,11 @@
 						$code .= $this->convert_tree($value['sub_branch'],$name,$iconDir,$parent.'.'.$id);
 						break;
-					
+
 					case 'catalog':
 						$code .= $name.".add(new dNode({id: '{$parent}.{$id}', caption: '{$value['name']}', onClick: 'setCatalog(\\'{$parent}.{$id}\\')'}),'$parent');\n";
-						
-				}
-			}
-			
+
+				}
+			}
+
 			return $code;
 		}
Index: /trunk/contactcenter/inc/class.Thread.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.Thread.inc.php	(revision 284)
+++ /trunk/contactcenter/inc/class.Thread.inc.php	(revision 284)
@@ -0,0 +1,102 @@
+<?php
+	/***********************************************************************************\
+	* eGroupWare - Contacts Center                                              		*
+	* http://www.egroupware.org                                                 		*
+	* Written by:                                                               		*
+	*  - Brian W. Bosh from	Multi-threading strategies in PHP at						*
+	* http://www.alternateinterior.com/2007/05/multi-threading-strategies-in-php.html	*
+	* Adapted by:																		*
+	*  - Mário César Kolling <mario.kolling@serpro.gov.br>								*
+	* ----------------------------------------------------------------------------------*
+	*  This program is free software; you can redistribute it and/or modify it  		*
+	*  under the terms of the GNU General Public License as published by the    		*
+	*  Free Software Foundation; either version 2 of the License, or (at your   		*
+	*  option) any later version.                                               		*
+	\***********************************************************************************/
+
+	require 'ThreadUtility.inc.php';
+
+	/*
+	 * This is the class that abstracts the details of process management
+	 */
+
+	class Thread {
+		var $pref ;
+		var $pipes;
+		var $pid;
+		var $stdout;
+		//var $timeout;
+
+		function Thread() {
+			$this->pref = 0;
+			$this->stdout = "";
+			$this->pipes = (array)NULL;
+			//$this->timeout = 30000;
+		}
+
+		function Create ($url, $env) {
+			$t = new Thread;
+			$descriptor = array (0 => array ("pipe", "r"), 1 => array ("pipe", "w"), 2 => array ("pipe", "w"));
+			$t->pref = proc_open ("php -q ". "/var/www/expresso/contactcenter/inc/" . $url, $descriptor, $t->pipes, NULL, $env);
+			stream_set_blocking ($t->pipes[1], 0);
+			stream_set_blocking ($t->pipes[2], 0);
+			//usleep ($this->timeout);
+			return $t;
+		}
+
+		function isActive () {
+			$status = proc_get_status($this->pref);
+			return $status['running'];
+		}
+
+		function close () {
+			$r = proc_terminate($this->pref);
+			$this->pref = NULL;
+			return $r;
+		}
+
+		function tell ($thought, $params = NULL) {
+		    fwrite ($this->pipes[0], $thought . "\n");
+			if (is_array ($params)) {
+				foreach ($params as $param) {
+					fwrite ($this->pipes[0], $param . "\n");
+				}
+			}
+		}
+
+		function readResponse()
+		{
+			$response = NULL;
+			$read = array($this->pipes[1]);
+			$write = NULL;
+			$exception = NULL;
+
+			if (stream_select($read, $write, $exception, 0) > 0){
+				$response = $this->listen();
+				return processresponse($response);
+			}
+			else
+			{
+				return $response;
+			}
+		}
+
+		function listen () {
+			$buffer = $this->stdout;
+			$this->stdout = "";
+			while ($r = fgets ($this->pipes[1], 1024)) {
+				$buffer .= $r;
+			}
+			return $buffer;
+		}
+
+		function getError () {
+			$buffer = "";
+			while ($r = fgets ($this->pipes[2], 1024)) {
+				$buffer .= $r;
+			}
+			return $buffer;
+		}
+	}
+
+?>
